; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Cubix"
!define PRODUCT_VERSION "1.0.0"
!define PRODUCT_PUBLISHER "TveirEinir.com"
!define PRODUCT_WEB_SITE "http://cubix.tveireinir.com"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\Cubix.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
;!insertmacro MUI_PAGE_LICENSE "c:\path\to\licence\YourSoftwareLicence.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\Cubix.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Icelandic"

; MUI end ------

;Vista fix
RequestExecutionLevel admin

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "CubixInstaller.exe"
InstallDir "$PROGRAMFILES\Cubix"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite try
    File "dist\_ctypes.pyd"
    File "dist\_imaging.pyd"
    File "dist\_socket.pyd"
    File "dist\_sqlite.pyd"
    File "dist\_ssl.pyd"
    File "dist\bz2.pyd"
    File "dist\cubix.exe"
    File "dist\data.cbx"
    File "dist\glut32.dll"
    File "dist\library.zip"
    File "dist\MSVCR71.dll"
    File "dist\pyexpat.pyd"
    File "dist\PyOpenGL-3.0.0a6-py2.4.egg"
    File "dist\python24.dll"
    File "dist\unicodedata.pyd"
    File "dist\w9xpopen.exe"
    File "dist\zlib.pyd"
  CreateDirectory "$SMPROGRAMS\Cubix"
  CreateShortCut "$SMPROGRAMS\Cubix\Cubix.lnk" "$INSTDIR\Cubix.exe"
  CreateShortCut "$DESKTOP\Cubix.lnk" "$INSTDIR\Cubix.exe"
SectionEnd

Section -AdditionalIcons
  CreateShortCut "$SMPROGRAMS\Cubix\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\Cubix.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\Cubix.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  
    Delete "$INSTDIR\_ctypes.pyd"
    Delete "$INSTDIR\_imaging.pyd"
    Delete "$INSTDIR\_socket.pyd"
    Delete "$INSTDIR\_sqlite.pyd"
    Delete "$INSTDIR\_ssl.pyd"
    Delete "$INSTDIR\bz2.pyd"
    Delete "$INSTDIR\cubix.exe"
    Delete "$INSTDIR\data.cbx"
    Delete "$INSTDIR\glut32.dll"
    Delete "$INSTDIR\library.zip"
    Delete "$INSTDIR\MSVCR71.dll"
    Delete "$INSTDIR\pyexpat.pyd"
    Delete "$INSTDIR\PyOpenGL-3.0.0a6-py2.4.egg"
    Delete "$INSTDIR\python24.dll"
    Delete "$INSTDIR\unicodedata.pyd"
    Delete "$INSTDIR\w9xpopen.exe"
    Delete "$INSTDIR\zlib.pyd"
    Delete "$INSTDIR\uninst.exe"

  Delete "$SMPROGRAMS\Cubix\Cubix.lnk"
  Delete "$SMPROGRAMS\Cubix\Uninstall.lnk"
  Delete "$DESKTOP\Cubix.lnk"

  RMDir "$SMPROGRAMS\Cubix"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd